



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>详解XMLHttpRequest的跨域资源共享</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">详解XMLHttpRequest的跨域资源共享</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 23:38:39 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>0x00 背景</h3>
<hr />
<p>在<a href="http://drops.wooyun.org/papers/151" rel="external nofollow noreferrer">Browser Security-同源策略、伪URL的域</a>这篇文章中提到了浏览器的同源策略，其中提到了XMLHttpRequest严格遵守同源策略，非同源不可请求。但是，在实践当中，经常会出现需要跨域请求资源的情况，比较典型的例如某个子域名向负责进行用户验证的子域名请求用户信息等应用。</p>
<p>以往，有一种解决方案是利用JSONP进行跨域的资源请求，但这种方案存在着几点缺陷:</p>
<pre class="prettyprint linenums">1)只能进行GET请求<br />
2)缺乏有效的错误捕获机制。因此在XMLHttpRequest v2标准下，提出了CORS(Cross Origin Resourse-Sharing)的模型，试图保证跨域请求的安全性。
</pre>
<p>现在，各大主流浏览器均支持CORS模型，其中IE 8, IE 9需要使用XDomainRequest进行跨域请求。</p>
<h3>0x01 基本模型</h3>
<hr />
<p>虽然说允许了XMLHttpRequest的跨域请求，但是这种许可并不是无条件的。</p>
<p>浏览器在进行请求时也会判断请求的合法性，验证是通过服务器的返回头来进行的，这时就涉及到了具体的请求类型，所以在标准中定义了简单跨域请求。</p>
<p>简单跨域请求就是满足下列条件的请求:</p>
<pre class="prettyprint linenums">请求方法为GET或POST<br />
请求方法中没有设置请求头(Accept, Accept-Language, Content-Language, Content-Type除外)<br />
如果设置了Content-Type头，其值为application/x-www-form-urlencoded, multipart/form-data或 text/plain
</pre>
<p>验证简单跨域请求与非简单跨域请求合法性的区别就在于，验证非简单跨域请求前，浏览器向服务器发送一个OPTIONS方法的预检请求来加以判断，如果预检失败，实际请求将被丢弃。而简单跨域请求浏览器会正常发送请求，再对返回头加以判断以检查请求的合法性。在检查失败时，浏览器将会阻止脚本对返回内容的访问。</p>
<p>在<a href="http://zone.wooyun.org/content/4917" rel="external nofollow noreferrer">http://zone.wooyun.org/content/4917</a>中，LZ因为设定了X-Forward-For头，所以浏览器先发送了预检请求，检查失败后丢弃了实际头，所以造成了LZ的误解。</p>
<h3>0x02 请求时发送的HTTP头</h3>
<hr />
<p>简单跨域请求并不会包含下面的HTTP头。而预检请求将会发送以下HTTP头</p>
<pre class="prettyprint linenums">Origin: 普通的HTTP请求也会带有，在CORS中专门作为Origin信息供后端比对<br />
Access-Control-Request-Method: 接下来请求的方法，例如PUT, DELETE等等<br />
Access-Control-Request-Headers: 自定义的头部，所有用setRequestHeader方法设置的头部都将会以逗号隔开的形式包含在这个头中
</pre>
<p>其他头，例如实际请求的头部，Cookie头等都将不被包含在预检请求中。</p>
<h3>0x03 返回的HTTP头</h3>
<hr />
<p>浏览器主要通过返回的这些HTTP头判断请求是否合法。值得注意的一点是，预检请求通过并不代表请求一定会成功，如果预检请求时服务器返回的HTTP头使浏览器判断请求合法，从而发出了实际请求，但是实际请求的返回头中含有的访问控制头显示请求不合法时，浏览器仍会判定请求不合法，从而向脚本隐藏返回的细节。</p>
<pre class="prettyprint linenums">Access-Control-Allow-Origin: 允许跨域访问的域，可以是一个域的列表，也可以是通配符"*"。这里要注意Origin规则只对域名有效，并不会对子目录有效。即http://foo.example/subdir/是无效的。但是不同子域名需要分开设置，这里的规则可以参照那篇同源策略<br />
Access-Control-Allow-Credentials: 是否允许请求带有验证信息，这部分将会在下面详细解释<br />
Access-Control-Expose-Headers: 允许脚本访问的返回头，请求成功后，脚本可以在XMLHttpRequest中访问这些头的信息(貌似webkit没有实现这个)<br />
Access-Control-Max-Age: 缓存此次请求的秒数。在这个时间范围内，所有同类型的请求都将不再发送预检请求而是直接使用此次返回的头作为判断依据，非常有用，大幅优化请求次数<br />
Access-Control-Allow-Methods: 允许使用的请求方法，以逗号隔开<br />
Access-Control-Allow-Headers: 允许自定义的头部，以逗号隔开，大小写不敏感
</pre>
<p>无论是预检请求或是实际请求，如果在<code>Access-Control-Allow-Origin, Access-Control-Allow-Credentials, Access-Control-Allow-Methods, Access-Control-Allow-Headers</code>的检查失败，就会被视为请求失败。</p>
<h3>0x04 单独谈谈Credentials</h3>
<hr />
<p>在跨域请求中，默认情况下，HTTP Authentication信息，Cookie头以及用户的SSL证书无论在预检请求中或是在实际请求都是不会被发送的。</p>
<p>但是，通过设置XMLHttpRequest的credentials为true，就会启用认证信息机制。</p>
<p>虽然简单请求还是不需要发送预检请求，但是此时判断请求是否成功需要额外判断Access-Control-Allow-Credentials，如果Access-Control-Allow-Credentials为false，请求失败。</p>
<p>十分需要注意的的一点就是此时Access-Control-Allow-Origin不能为通配符"*"(真是便宜了一帮偷懒的程序员)，如果Access-Control-Allow-Origin是通配符"*"的话，仍将认为请求失败</p>
<p>即便是失败的请求，如果返回头中有Set-Cookie的头，浏览器还是会照常设置Cookie</p>
<h3>0x05 CORS中的安全隐患</h3>
<hr />
<p>最大的隐患就在于某些偷懒的程序员会将Access-Control-Allow-Origin设置为"*"从而使得这个CORS模型基本失效，但是由于Credentials模型的保护，很多网上的文章认为的信息泄露问题其实并不存在。在这里的风险其实是可以构造DDoS进行攻击。</p>
<p>另外就是我们会发现，虽然无法得到返回值，简单请求其实是发出的，所以POST请求是可以发出的。这时候，其实就和平常的CSRF一样了，所以并不是说保证了跨域请求限定的域就可以不做CSRF防范了。</p>
<p>转载自：http://drops.wooyun.org/tips/188</p>
<div>&nbsp;</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqdvozqd.html">压缩SWF文件大小！减少40&percnt;体积！</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwn5mkq.html">Dojo框架学习笔记&amp;lt&semi;一&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1wel29.html">Ajax异步刷新地址栏url改变（利用Html5 history&period;pushState实现）</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8omdzeq.html">记录一次Mac虚拟机安装的过程（有图有真相）</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kwx3j8.html">mount part中位置的作用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjk5k79.html">poj - 3683 - Priest John&amp;&num;39&semi;s Busiest Day（2-SAT）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjym6y9.html">第3章 Struts2框架--2、完整的Struts2框架应用实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xr1kr9.html">PHP 编译问题PEAR package PHP&lowbar;Archive not installed的解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ovyg49.html">mysql-cluster集群原理介绍和搭建步骤&lpar;四个data&sol;sql节点&rpar;  &lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/950xj3z8.html">MySQL备份方案--&amp;gt&semi;（利用mysqldump以及binlog二进制日志）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pddvp79.html">部署Redis主-从</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpg060q.html">IT类非开发面试总结--2</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo0771q.html">deepin 开机进入 initramfs&comma;无法开机</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7od25k8.html">python练习题-day9</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyen5d9.html">Visual Studio 2017 调试器的工作进程（msvsmon&period;exe）意外退出 调试将终止</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjvdnz9.html">输出列表为字符串，并在最后一个值前加上and 4&period;10&period;1</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll3v46q.html">Vue&period;js是什么，vue介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkv01x8.html">android speakerphone&sol;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko50wjq.html">python 多线程稀疏矩阵乘法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko41z3q.html">C&num;中ASCII码与字符串的互换</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qyvg1lmq.html">POJ 3320 Jessica&amp;&num;39&semi;s Reading Problem &lpar;滑动窗口&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvgyojq.html">配置 cxf-ws spring bean 文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gpgjle9.html">C语言中交换两个数值的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvekekj9.html">linux 各项配置汇总</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnnwn42q.html">&lpar;欧拉公式  很水&rpar;  Coprimes -- sgu  -- 1002</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2yl3e8.html">POJ1062不错的题&mdash;&mdash;spfa倒向建图&mdash;&mdash;枚举等级限制</a>
			</li>
						<li><a href="https://www.batexi.com/a/93p7jew8.html">jsp ckeditor ckfinder</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2k3mkwq.html">我的成长比价系列：java web开发过程中遇到的错误一：sql语句换行错误</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ko2n2rq.html">Python 实现WC功能</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o4yv2eq.html">How to create a Multi-device Site - some details</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
